#include <stdio.h>
#include <windows.h>
#include <topic.cpp>
#include <discipline.cpp>
#include <screen.cpp>

#define WINDOW_NAME "AskMe 2.0"
#define BASE_PATH "Base\\"
#define MASK "*.txt"
#define STAT_STR_SIZE 48
#define TITLE_SIZE 1024
#define DSCPLN_NUMBER 64
#define TOPICS_NUMBER 128
#define Q_NUMBER 1024
#define VENTRY_NUMBER 64
#define LEFT_MAX (VENTRY_NUMBER/2-1)
#define LEFT_START 0
#define RIGHT_START VENTRY_NUMBER/2

#define ID_MENUDISCIPLINE 20
#define ID_TOPIC 100
#define ID_OWNEDOK 200
#define ID_MAINOK 300
#define ID_VARIANTSTART 1000
#define ID_NUM 10000

#define Y_START 10
#define MENU_HEIGHT 60
#define TOPIC_WIDTH 250
#define TOPIC_HEIGHT 60
#define TOPIC_COLUMNS 3
#define VAR_HEIGHT 20
#define OKBUTTON_HEIGHT 30
#define WINDOWTITLE_HEIGHT 30
#define SPACER 15

LRESULT CALLBACK WndProc(HWND hWnd,UINT msg, WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK OwnedProc(HWND hwnd, UINT Message, WPARAM wparam,LPARAM lparam);

void Init();
void WM_PaintTask(HDC hDC);
//int PlaceQuestion2(int ToInsert, bool bReset);
int PlaceQuestion2(int ToInsert);

Screen2 OnScreen2;
TopicClass Topic_test;
DisciplineClass Discipline;

bool bWMFirst=1;
int nPaint=0;

//HINSTANCE hInst;
//int QCount=-1;
//int nCycle=1;
//int nID=ID_VARIANTSTART;
//HWND hOwned;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int iCmdShow)
    {
    MSG msg;
    char ToSearch[PATH_SIZE];
    HMENU hMainMenu;
    HMENU hDscplnMenu;
    HMENU hHelpMenu;

//    hInst=hInstance;
    OnScreen2.hInst=hInstance;
    Init();
    sprintf(ToSearch, "%s%s", BASE_PATH, MASK);
    Discipline.LoadDisciplines(ToSearch);

    hMainMenu = CreateMenu();
    hDscplnMenu = CreatePopupMenu();
//    hHelpMenu = CreatePopupMenu();
    for (int i=0;i<=Discipline.DCount_ext;i++)
    {
	OnScreen2.CreateMenuItem(hDscplnMenu, Discipline.Dscpln[i].title, 0, ID_MENUDISCIPLINE+i, NULL);
    }

    hHelpMenu = CreatePopupMenu();
    OnScreen2.CreateMenuItem(hHelpMenu, "О программе", 1, ID_MENUABOUT, NULL);
    OnScreen2.CreateMenuItem(hHelpMenu, "Горячие клавиши", 1, ID_MENUHOTKEYS, NULL);
    OnScreen2.CreateMenuItem(hHelpMenu, "База данных", 1, ID_MENUINFO, NULL);
    OnScreen2.CreateMenuItem(hMainMenu, "Дисциплины", 0, 0, hDscplnMenu);
    OnScreen2.CreateMenuItem(hMainMenu, "Помощь", 1, 0, hHelpMenu);

    OnScreen2.hWnd = CreateWindowEx
	(0,
	"MainWClass",
	WINDOW_NAME,
	WS_OVERLAPPEDWINDOW,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	(HWND) NULL,
	(HMENU) hMainMenu,
	hInstance,
	NULL);
    ShowWindow(OnScreen2.hWnd,SW_MAXIMIZE);
    UpdateWindow(OnScreen2.hWnd);
    OnScreen2.Init();

    ACCEL acc[VAR_NUMBER+2];
    acc[0].key='1';
    for(int i=0;i<VAR_NUMBER;i++)
    {
	acc[i].cmd = ID_NUM+i;
	acc[i].fVirt = (BYTE)NULL;
	acc[i].key=acc[0].key+i;
    }
    acc[VAR_NUMBER].cmd = ID_MAINOK;
    acc[VAR_NUMBER].fVirt = (BYTE)NULL;
    acc[VAR_NUMBER].key = (char)13;

    acc[VAR_NUMBER+1].cmd = ID_MAINOK;
    acc[VAR_NUMBER+1].fVirt = (BYTE)NULL;
    acc[VAR_NUMBER+1].key = (char)32;

    HACCEL hAccel = CreateAcceleratorTable((LPACCEL)acc, VAR_NUMBER+2);

    while(GetMessage(&msg,NULL,0,0))
    {
	if(!(hAccel && TranslateAccelerator(OnScreen2.hWnd, hAccel, &msg)))
	{
	TranslateMessage(&msg);
	DispatchMessage(&msg);
	}
    }
    DestroyAcceleratorTable(hAccel);
    return msg.wParam;
    }

LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
    {
    static int QCurrent=0;
    static bool bFirst=TRUE;

    switch(msg)
    {
case WM_PAINT:
    {
nPaint++;
//MessageBox(hWnd,"123","Информация",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
//if(bWMFirst)
//{
	HDC hDC;
	PAINTSTRUCT ps;
	hDC=BeginPaint(OnScreen2.hWnd,&ps);
	WM_PaintTask(hDC);
	EndPaint(OnScreen2.hWnd,&ps);
//}
    }
break;

case WM_COMMAND:
    {
    OnScreen2.Anounce(wParam);

    for(int i=0;i<DSCPLN_NUMBER;i++)
    {
	if((LOWORD(wParam)==ID_MENUDISCIPLINE+i)&&(Discipline.Dscpln[i].loaded))
	{
//MessageBox(OnScreen2.hWnd,ct,MB_OK);
	Discipline.UnloadTopics();
	Discipline.LoadTopics(Discipline.Dscpln[i]);
//	Discipline.DrawChooser(hInst, OnScreen2.hWnd, OnScreen2.hOwned, OnScreen2.rMainWindow.bottom, OnScreen2.rMainWindow.right, Discipline.Dscpln[i].path);
//	Discipline.DrawChooser(OnScreen2.hInst, OnScreen2.hWnd, OnScreen2.hOwned, OnScreen2.rMainWindow.bottom, OnScreen2.rMainWindow.right, Discipline.Dscpln[i].path);
	Discipline.DrawChooser(OnScreen2.hInst, OnScreen2.hWnd, OnScreen2.hOwned, OnScreen2.rMainWindow, Discipline.Dscpln[i].path);
//test
//char ct[10];
//sprintf(ct,"%d",1);
//MessageBox(hWnd,ct,"Информация",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
	}
    }

    for(int i=0;i<VAR_NUMBER;i++)
    {
	if((LOWORD(wParam)==ID_NUM+i)&&(bFirst))
	{
	int nIDComponent=Topic_test.GetIDComponent(QCurrent);
	for(int j=0;j<VAR_NUMBER;j++)
	{
		if((Topic_test.Get(QCurrent)->variant[j].loaded)&&(i==j))
		{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+j);
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if(res == BST_CHECKED) SendMessage (hwndCheck, BM_SETCHECK, BST_UNCHECKED, 0);
		else SendMessage (hwndCheck, BM_SETCHECK, BST_CHECKED, 0);
		}
	}
	}
    }

    if(!bFirst)
    {
    int nIDComponent=Topic_test.GetIDComponent(QCurrent);
    for(int i=0;i<VAR_NUMBER;i++)
    {
	if(LOWORD(wParam)==(ID_VARIANTSTART+nIDComponent+i))
	{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+i);
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if(res == BST_CHECKED) SendMessage (hwndCheck, BM_SETCHECK, BST_UNCHECKED, 0);
		else SendMessage (hwndCheck, BM_SETCHECK, BST_CHECKED, 0);
	}
    }
    }

    if (LOWORD(wParam)==ID_MAINOK)
    {
    static bool bOK=TRUE;
    int nIDComponent=Topic_test.GetIDComponent(QCurrent);
	for(int i=0;i<VAR_NUMBER;i++)
	{
	if(Topic_test.Get(QCurrent)->variant[i].loaded)
	{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+i);
		if(bFirst)
		{
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if((res == BST_CHECKED)&&(Topic_test.Get(QCurrent)->variant[i].correct))
			{SendMessage (hwndCheck, WM_SETFONT, (WPARAM)OnScreen2.hCorrect, 1);}
		if((res == BST_CHECKED)&&(!Topic_test.Get(QCurrent)->variant[i].correct))
			{bOK=FALSE;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)OnScreen2.hExcessive, 1);}
		if((res == BST_UNCHECKED)&&(Topic_test.Get(QCurrent)->variant[i].correct))
			{bOK=FALSE;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)OnScreen2.hMissing, 1);}
		}
		else EnableWindow(hwndCheck,0);
	}
	}
	if((bOK)&&(bFirst)) {Topic_test.Get(QCurrent)->completed=TRUE;}
	if(bFirst)
	{
//        Topic_test.GetStat(nCycle,0,OnScreen2.hWnd);
        Topic_test.GetStat(0,OnScreen2.hWnd);
	}
	if(!bFirst)
	{
	bOK=TRUE;
//char ct[10];
//sprintf(ct,"%d",Topic_test.nCurLevel);
//MessageBox(hWnd,ct,"Информация",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
//sprintf(ct,"%d",Topic_test.Get(QCurrent)->showed);
//MessageBox(hWnd,ct,"Информация",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
	QCurrent=Topic_test.GetNextQuestion(QCurrent+1);
		if(QCurrent==-1)
			{
//			nID=ID_VARIANTSTART-1;
//			Topic_test.GetStat(nCycle,1,OnScreen2.hWnd);
			Topic_test.GetStat(1,OnScreen2.hWnd);
//			nCycle++;
Topic_test.nCurLevel++;
			OnScreen2.HideAll();
			OnScreen2.RemoveInvisible();
			SetWindowText(OnScreen2.hWnd,WINDOW_NAME);
			QCurrent=Topic_test.GetNextQuestion(0);
			if(QCurrent==-1)
			{
			MessageBox(NULL,"Game over","Game over",MB_OK);
//			nCycle=1;
Topic_test.nCurLevel=0;
			QCurrent=-1;
			OnScreen2.HideAll();
			OnScreen2.RemoveInvisible();
			SetWindowText(OnScreen2.hWnd,WINDOW_NAME);
			Discipline.UnloadTopics();
			}
			}
//		PlaceQuestion2(QCurrent,0);
		PlaceQuestion2(QCurrent);
	}
	bFirst=!bFirst;
    }
return -1;
    }
break;

case (WM_USER):
    {
	OnScreen2.HideAll();
	OnScreen2.RemoveInvisible();
	OnScreen2.Cleaner();
	QCurrent=0;
	bFirst=TRUE;
	SetWindowText(OnScreen2.hWnd,WINDOW_NAME);
//	PlaceQuestion2(QCurrent,1);
	PlaceQuestion2(QCurrent);
    }
break;

case WM_DESTROY:
    PostQuitMessage(0);
break;

default:
return DefWindowProc(hWnd,msg,wParam,lParam);
    }

return 0;
    }

LRESULT CALLBACK OwnedProc (HWND hwnd, UINT Message, WPARAM wparam, LPARAM lparam)
    {
    switch (Message)
    {

case WM_CREATE:
    {
	EnableWindow(OnScreen2.hWnd,0);
	EnableWindow(OnScreen2.hWnd,1);
    }
break;

case WM_COMMAND:
    {
    if(LOWORD(wparam)==ID_OWNEDOK)
    {
    bool bChosen=FALSE;
    for(int i=0;i<TOPICS_NUMBER;i++)
    {
	if (Discipline.Topic[i].loaded)
	{
	HWND hwndCheck = GetDlgItem(hwnd, i+ID_TOPIC);
	LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
	if(res==BST_CHECKED)
	    {
	    Topic_test.UnloadQuestions();
	    Topic_test.LoadQuestions(Discipline.Topic[i].path);
    	    bChosen=TRUE;
    	    }
	}
    }

    if(bChosen) {PostMessage(OnScreen2.hWnd,WM_USER,0,0);}
    DestroyWindow(hwnd);
    }
return -1;
    }
break;

case WM_DESTROY:
    {
	EnableWindow(OnScreen2.hWnd,1);
	BringWindowToTop(OnScreen2.hWnd);
return 0;
    }
break;

default:
return DefWindowProc(hwnd,Message,wparam,lparam);
    }
    }

void Init()
    {
    WNDCLASSEX wc;
    WNDCLASS w;

    wc.cbSize=sizeof(wc);
    wc.cbClsExtra=0;
    wc.cbWndExtra=0;
    wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW;
    wc.hCursor=LoadCursor(0,IDC_ARROW);
    wc.hIcon=LoadIcon(OnScreen2.hInst,IDI_APPLICATION);
//    wc.hIcon=LoadIcon(hInst,IDI_APPLICATION);
//    wc.hIconSm=LoadIcon(hInst,IDI_APPLICATION);
    wc.hIconSm=LoadIcon(OnScreen2.hInst,IDI_APPLICATION);
//    wc.hInstance=hInst;
    wc.hInstance=OnScreen2.hInst;
    wc.lpfnWndProc=WndProc;
    wc.lpszClassName="MainWClass";
    wc.lpszMenuName=NULL;
    wc.style=CS_HREDRAW | CS_VREDRAW;
    RegisterClassEx(&wc);

    memset(&w,0,sizeof(WNDCLASS));
    w.lpfnWndProc = OwnedProc;
//    w.hInstance = hInst;
    w.hInstance = OnScreen2.hInst;
    w.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;
    w.lpszClassName = "OwnedWClass";
    w.hCursor=LoadCursor(NULL,IDC_CROSS); 
    RegisterClass(&w);
    }

void WM_PaintTask(HDC hDC)
    {
if(bWMFirst)
{
    SetBkMode(hDC,TRANSPARENT);
    for(int i=0;i<VENTRY_NUMBER;i++)
    {
    if(OnScreen2.Entry[i].visible)
    DrawText(
	hDC,
	Topic_test.Get(OnScreen2.Entry[i].qNumber)->task,
	strlen(Topic_test.Get(OnScreen2.Entry[i].qNumber)->task),
	&OnScreen2.Entry[i].task,
	DT_WORDBREAK);
    }
}
bWMFirst=0;
    }

//int PlaceQuestion2(int ToInsert, bool bReset)
int PlaceQuestion2(int ToInsert)
    {
int nID=ID_VARIANTSTART-1;
//    if(bReset) nID=ID_VARIANTSTART-1;

    RECT tmp;
    int nTaskHeight,nVariantsHeight,nVarCount=0,nIDComponent=0;
    HDC hDC;
    int nCoefficient=1;
    float fCoefficient,fChar;

    if(ToInsert==-1) return 0;

    tmp.left=0;
    tmp.right=OnScreen2.rMainWindow.right/2;
    tmp.top=0;
    tmp.bottom=SPACER;

    hDC=GetDC(OnScreen2.hWnd);
    DrawText(hDC, Topic_test.Get(ToInsert)->task, strlen(Topic_test.Get(ToInsert)->task), &tmp, DT_CALCRECT|DT_WORDBREAK);
    ReleaseDC(OnScreen2.hWnd,hDC);

    nTaskHeight=tmp.bottom-tmp.top;
    nTaskHeight+=SPACER;

    nVariantsHeight=0;
    for(int i=0;i<VAR_NUMBER;i++)
        {
        if(Topic_test.Get(ToInsert)->variant[i].loaded) 
        {nVariantsHeight+=Topic_test.Get(ToInsert)->variant[i].GetCoefficient(OnScreen2.fChar_test)*VAR_HEIGHT;}
        }

    OnScreen2.CurrentPosition++;
    if(OnScreen2.CurrentPosition==VENTRY_NUMBER) {OnScreen2.CurrentPosition=0;}

    if(OnScreen2.CurrentPosition!=0)
    {
    if(
	(OnScreen2.Entry[OnScreen2.CurrentPosition-1].variants.bottom
	+nTaskHeight
	+nVariantsHeight
	+OKBUTTON_HEIGHT)
	>(OnScreen2.rMainWindow.bottom-Y_START))
	{if((OnScreen2.CurrentPosition<=LEFT_MAX)|(OnScreen2.CurrentPosition==RIGHT_START))
		{OnScreen2.CurrentPosition=RIGHT_START;}
	else OnScreen2.CurrentPosition=LEFT_START;}
    }

    if(OnScreen2.CurrentPosition!=0)
    {
    if((OnScreen2.Entry[OnScreen2.CurrentPosition-1].variants.bottom
	+nTaskHeight
	+nVariantsHeight
	+OKBUTTON_HEIGHT)<OnScreen2.Entry[OnScreen2.CurrentPosition].task.top)
	{OnScreen2.InsertPosition(OnScreen2.CurrentPosition);}
    }
    OnScreen2.Entry[OnScreen2.CurrentPosition].visible=FALSE;
    OnScreen2.RemoveInvisible();

    if((OnScreen2.CurrentPosition==LEFT_START)|(OnScreen2.CurrentPosition==RIGHT_START)) OnScreen2.Entry[OnScreen2.CurrentPosition].task.top=Y_START;
    else OnScreen2.Entry[OnScreen2.CurrentPosition].task.top=OnScreen2.Entry[OnScreen2.CurrentPosition-1].variants.bottom;

    OnScreen2.Entry[OnScreen2.CurrentPosition].task.bottom=OnScreen2.Entry[OnScreen2.CurrentPosition].task.top+nTaskHeight;
    OnScreen2.Entry[OnScreen2.CurrentPosition].variants.top=OnScreen2.Entry[OnScreen2.CurrentPosition].task.bottom;
    OnScreen2.Entry[OnScreen2.CurrentPosition].variants.bottom=OnScreen2.Entry[OnScreen2.CurrentPosition].variants.top+nVariantsHeight;

    if(OnScreen2.CurrentPosition<=LEFT_MAX)
    {
        OnScreen2.Entry[OnScreen2.CurrentPosition].task.left=OnScreen2.Entry[OnScreen2.CurrentPosition].variants.left=SPACER;
        OnScreen2.Entry[OnScreen2.CurrentPosition].task.right=OnScreen2.Entry[OnScreen2.CurrentPosition].variants.right=OnScreen2.rMainWindow.right/2;
    }
    else
    {
        OnScreen2.Entry[OnScreen2.CurrentPosition].task.left=OnScreen2.Entry[OnScreen2.CurrentPosition].variants.left=SPACER+OnScreen2.rMainWindow.right/2;
        OnScreen2.Entry[OnScreen2.CurrentPosition].task.right=OnScreen2.Entry[OnScreen2.CurrentPosition].variants.right=OnScreen2.rMainWindow.right;
    }

    OnScreen2.Entry[OnScreen2.CurrentPosition].visible=1;
    OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber=ToInsert;

    for(int i=1;i<VENTRY_NUMBER/2;i++)
    {
	if(OnScreen2.CurrentPosition!=(VENTRY_NUMBER-i))
	{
	if
	(
		((OnScreen2.CurrentPosition<=LEFT_MAX)&&(OnScreen2.CurrentPosition+i)<=LEFT_MAX)|
		((OnScreen2.CurrentPosition>=RIGHT_START)&&(OnScreen2.CurrentPosition+i)>=RIGHT_START)
	)
	{
	if((OnScreen2.Entry[OnScreen2.CurrentPosition].variants.bottom+OKBUTTON_HEIGHT)>OnScreen2.Entry[OnScreen2.CurrentPosition+i].task.top)
		OnScreen2.Entry[OnScreen2.CurrentPosition+i].visible=FALSE;
	}
	}
    }
    OnScreen2.RemoveInvisible();

    hDC=GetDC(OnScreen2.hWnd);
    SetBkMode(hDC,TRANSPARENT);
    DrawText
	(hDC,
	Topic_test.Get(ToInsert)->task,
	strlen(Topic_test.Get(ToInsert)->task),
	&OnScreen2.Entry[OnScreen2.CurrentPosition].task,
	DT_WORDBREAK);
    ReleaseDC(OnScreen2.hWnd,hDC);

    for(int i=0;i<VAR_NUMBER;i++)
    {
	if(Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->variant[i].loaded)
	{
//		if(Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->showed!=0)
//		{
		nIDComponent=Topic_test.GetIDComponent(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber);
		nID=ID_VARIANTSTART-1+nIDComponent+nVarCount;
//		}
	nID++;
	OnScreen2.Entry[OnScreen2.CurrentPosition].hVariant[i]=
		CreateWindow
		("button",
		Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->variant[i].text,
		WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX|BS_MULTILINE,
		OnScreen2.Entry[OnScreen2.CurrentPosition].variants.left,
		OnScreen2.Entry[OnScreen2.CurrentPosition].variants.top+
		VAR_HEIGHT*Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->GetSumCoefficient(i,OnScreen2.fChar_test),
		OnScreen2.Entry[OnScreen2.CurrentPosition].variants.right-OnScreen2.Entry[OnScreen2.CurrentPosition].variants.left,
		VAR_HEIGHT*Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->variant[i].GetCoefficient(OnScreen2.fChar_test),
		OnScreen2.hWnd,
		(HMENU)nID,
		OnScreen2.hInst,
		NULL);
	nVarCount++;
	}
    }
    OnScreen2.Entry[OnScreen2.CurrentPosition].hOK=CreateWindow(
	"button",
	"OK",
	WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
	OnScreen2.Entry[OnScreen2.CurrentPosition].variants.left,
	OnScreen2.Entry[OnScreen2.CurrentPosition].variants.top+
	VAR_HEIGHT*Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->GetSumCoefficient(nVarCount,OnScreen2.fChar_test),
	OnScreen2.rMainWindow.right/2-2*SPACER,
	OKBUTTON_HEIGHT,
	OnScreen2.hWnd,
	(HMENU)ID_MAINOK,
	OnScreen2.hInst,
	NULL);
//    Topic_test.Get(OnScreen2.Entry[OnScreen2.CurrentPosition].qNumber)->showed++;
    Topic_test.Get(ToInsert)->showed++;
//test
char ct[10];
sprintf(ct,"%d",nPaint);
//MessageBox(OnScreen2.hWnd,ct,"Информация",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
bWMFirst=1;
PostMessage(OnScreen2.hWnd,WM_PAINT,0,0);
return 1;
    }
